/*                Bistro development code
* 
* This code may be freely distributed and modified under the
* terms of the GNU Lesser General Public Licence.  This should
* be distributed with the code.  If you do not have a copy,
* see:
*
*     http://www.gnu.org/copyleft/lesser.html
* 
* Copyright for this code is held jointly by the individual
* authors.  These should be listed in @author doc comments.
* 
*/

package org.starbeans.modules.bistro.data;

/**
 *
 */
public class DataType {
    
    /* No Instantiation */
    private DataType() {};

    	/** Type string for a string object */
	public static final String STRING = "'text/plain'";

	/** Type string for an array of string objects */
	public static final String STRING_ARRAY = "l('text/plain')";

	/** Type string for a PNG image */
	public static final String PNG_IMAGE = "'application/octet-stream,image/png'";

	/** Type string for an array of PNG images */
	public static final String PNG_IMAGE_ARRAY = "l('application/octet-stream,image/png')";

	/** Type string for a document in HTML format */
	public static final String HTML = "'text/plain,text/html'";

	/** Type string for an array of documents in HTML format */
	public static final String HTML_ARRAY = "l('text/plain,text/html'";

	/** Type string for arbitrary binary data */
	public static final String BINARY = "'application/octet-stream'";

	/** Type string for an array of arbitrary binary data blocks */
	public static final String BINARY_ARRAY = "l('application/octet-stream')";

	/** Type string for a single item of unknown type */
	public static final String UNTYPED = "''";

	/** Type string for an array of items of unknown type */
	public static final String UNTYPED_ARRAY = "l('')";
        
        public static String[] interestingTypes = new String[] { "text/html",
			"text/xml", "text/rtf", "text/x-graphviz", "image/png",
			"image/jpeg", "image/gif", "application/zip", "text/plain" };

}
