/*                Bistro development code
* 
* This code may be freely distributed and modified under the
* terms of the GNU Lesser General Public Licence.  This should
* be distributed with the code.  If you do not have a copy,
* see:
*
*     http://www.gnu.org/copyleft/lesser.html
* 
* Copyright for this code is held jointly by the individual
* authors.  These should be listed in @author doc comments.
* 
*/
package org.starbeans.modules.bistro.data;

/**
 * Thrown when metadata is requested for an object, no empty metadata element is
 * defined and there is no data stored.
 * 
 * @author Tom Oinn (Taverna)
 * @author EMBL-EBI
 */
public class NoMetadataFoundException extends RuntimeException {

	public NoMetadataFoundException() {
		super();
	}

	public NoMetadataFoundException(String message) {
		super(message);
	}

	public NoMetadataFoundException(String message, Exception cause) {
		super(message, cause);
	}

	public NoMetadataFoundException(Exception cause) {
		super(cause);
	}

}
