/*                Bistro development code
* 
* This code may be freely distributed and modified under the
* terms of the GNU Lesser General Public Licence.  This should
* be distributed with the code.  If you do not have a copy,
* see:
*
*     http://www.gnu.org/copyleft/lesser.html
* 
* Copyright for this code is held jointly by the individual
* authors.  These should be listed in @author doc comments.
* 
*/
package org.starbeans.modules.bistro.io;

import java.io.IOException;
import java.io.InputStream;
import java.util.Map;

/**
 * This class provides a useful extension point for Stream Processors.
 * 
 * @author Mark (Taverna)
 */
public abstract class AbstractStreamProcessor implements StreamProcessor {

	public static final String NEWLINE = System.getProperty("line.separator");

	/**
	 * @see net.sourceforge.taverna.io.StreamProcessor#processStream(java.io.InputStream)
	 */
	public abstract Map processStream(InputStream stream) throws IOException;

}
