/*                Bistro development code
* 
* This code may be freely distributed and modified under the
* terms of the GNU Lesser General Public Licence.  This should
* be distributed with the code.  If you do not have a copy,
* see:
*
*     http://www.gnu.org/copyleft/lesser.html
* 
* Copyright for this code is held jointly by the individual
* authors.  These should be listed in @author doc comments.
* 
*/
package org.starbeans.modules.bistro.io;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.HashMap;
import java.util.Map;
import org.starbeans.modules.bistro.data.DataThingAdapter;

/**
 * 
 * @author Mark (Taverna)
 */
public class GetStreamProcessor extends AbstractStreamProcessor implements StreamProcessor {

	public GetStreamProcessor() {

	}

	/**
	 * @see net.sourceforge.taverna.io.StreamProcessor#processStream(java.io.InputStream)
	 */
	public Map processStream(InputStream stream) throws IOException {
		HashMap outputMap = new HashMap();
		DataThingAdapter outAdapter = new DataThingAdapter(outputMap);
		StringBuffer sb = new StringBuffer(2000);

		BufferedReader rd = new BufferedReader(new InputStreamReader(stream));

		String str;

		while ((str = rd.readLine()) != null) {
			sb.append(str);
			sb.append(NEWLINE);
		}
		rd.close();

		outAdapter.putString("outputText", sb.toString());

		return outputMap;
	}

}
