/*                Bistro development code
* 
* This code may be freely distributed and modified under the
* terms of the GNU Lesser General Public Licence.  This should
* be distributed with the code.  If you do not have a copy,
* see:
*
*     http://www.gnu.org/copyleft/lesser.html
* 
* Copyright for this code is held jointly by the individual
* authors.  These should be listed in @author doc comments.
* 
*/
package org.starbeans.modules.bistro.io;

import java.io.IOException;
import java.io.InputStream;
import java.util.Map;

/**
 * This interface defines the basic method needed by all stream processors. A
 * stream processor is a delegate class that the StreamTransmitter uses to
 * process the result returned by a webserver request.
 * 
 * @author Mark (Taverna)
 */
public interface StreamProcessor {

	/**
	 * This method processes a result stream.
	 * 
	 * @param stream
	 */
	public Map processStream(InputStream stream) throws IOException;

}
