/*                Bistro development code
* 
* This code may be freely distributed and modified under the
* terms of the GNU Lesser General Public Licence.  This should
* be distributed with the code.  If you do not have a copy,
* see:
*
*     http://www.gnu.org/copyleft/lesser.html
* 
* Copyright for this code is held jointly by the individual
* authors.  These should be listed in @author doc comments.
* 
*/

package org.starbeans.modules.bistro.localservices;

import java.util.ArrayList;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import org.starbeans.modules.bistro.services.BioService;
import org.starbeans.modules.bistro.services.ServiceProcessorFactory;
import org.starbeans.modules.bistro.services.Worker;

/**
 *
 * @author George Waldon
 */
public abstract class LocalService implements BioService {

    // Thread-safe, no synchronization
    private final ArrayList<ChangeListener> listeners =
            new ArrayList<ChangeListener>();
    
    public String getName() {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public String getDescription() {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public Worker getWorker() {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public void addChangeListener(ChangeListener listener) {
        listeners.add(listener);
    }
    
    public void removeChangeListener(ChangeListener listener) {
        listeners.remove(listener);
    }
    
    protected void notifyChange() {
        for ( ChangeListener listener : listeners ) {
            listener.stateChanged(new ChangeEvent(this));
        }
    }

    public String getIconBase() {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public ServiceProcessorFactory getProcessorFactory() {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public void setProcessorfactory(ServiceProcessorFactory factory) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

}
