/*                Bistro development code
* 
* This code may be freely distributed and modified under the
* terms of the GNU Lesser General Public Licence.  This should
* be distributed with the code.  If you do not have a copy,
* see:
*
*     http://www.gnu.org/copyleft/lesser.html
* 
* Copyright for this code is held jointly by the individual
* authors.  These should be listed in @author doc comments.
* 
*/

package org.starbeans.modules.bistro.services;

import javax.swing.event.ChangeListener;

/** In Bistro, services are created from NetBeans xml filesystem. These services
 *  also serve as factory for the associated processors.
 *
 * @author George Waldon
 */
public interface BioService {
    
    /** Unique ID.
     * 
     */
    public String getID();
    
    public String getName();
    
    public String getDescription();
    
    public ServiceProcessorFactory getProcessorFactory();
    
    public void setProcessorfactory(ServiceProcessorFactory factory);
        
    public void addChangeListener(ChangeListener listener);
    
    public void removeChangeListener(ChangeListener listener);
    
    /* Get icon base with extension.
     */
    public String getIconBase();

}
