/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or sbbuild/licenses/cddl-gpl-2-cp.txt. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * sbbuild/licenses/cddl-gpl-2-cp.txt.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 2004-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */


package org.starbeans.modules.seqformat.parser;

import java.util.*;
import org.starbeans.modules.seqformat.source.*;
import org.starbeans.modules.seqformat.model.*;
import org.starbeans.modules.seqformat.srcgen.DocBinding;
import org.starbeans.modules.seqformat.srcgen.TextBinding;

/**
 *
 * @author  svata, George Waldon
 * @version 
 */
public class SrcInfo extends BaseElementInfo implements DocumentModelUpdater {
    ChildCollection     seqs;     
    SrcElement.Impl     sourceImpl;
    SeqModel.Updater    updater;    
    Element[]           newSeqs;
    
    private static final SeqElement[] NO_SEQS = new SeqElement[0];
    
    public SrcInfo() {
        super(null);
    }
    
    public Element createModelImpl(SeqModel.Updater model, Element parent) {
        return null;
    }

    public void addSequence(SeqInfo seq) {
        if (seqs == null) {
            seqs = new ChildCollection(SeqInfo.DEFAULT_SEQ_FINDERS, SeqElement.class); 
        }
        seqs.addChild(seq, -1);
    }
    
    // Called from ParsingSupport in UpdateModel() -> updateSourceModel(); 
    // updater = DocumentModelBuilder(); target is TextBinding binding from BaseElementInfo    
    public void updateBinding(DocBinding updater, TextBinding target) {
        Binding.Source sb = (Binding.Source)target;
        if (seqs != null) {
            updateChildren(updater, seqs.getChildren(), 
                (TextBinding.Container)sb.getSeqElementContainer());
        }
    }

    // Called from ParsingSupport, updater = defaultSeqModel
    public void updateModel(SeqModel.Updater updater, SrcElement src,
        SrcElement.Impl impl) throws SrcException {        
        updateElement(updater, src);
        this.sourceImpl = impl;         
        int[] seqMap = null;       
        if (seqs == null)
            newSeqs = NO_SEQS;
        else {
            newSeqs = seqs.updateChildren(src, updater, impl.getAllSeqElements());
            seqMap = seqs.getResultMap();
        }
        updater.updateMembers(src, ElementProperties.PROP_SEQELEMENT, newSeqs, null,seqMap);
    }
}
