/*                Bistro development code
* 
* This code may be freely distributed and modified under the
* terms of the GNU Lesser General Public Licence.  This should
* be distributed with the code.  If you do not have a copy,
* see:
*
*     http://www.gnu.org/copyleft/lesser.html
* 
* Copyright for this code is held jointly by the individual
* authors.  These should be listed in @author doc comments.
* 
*/
package org.starbeans.modules.bistro.onlineservices.ncbi;

import java.util.HashMap;
import java.util.Map;
import org.starbeans.modules.bistro.data.DataThingAdapter;
import org.starbeans.modules.bistro.task.TaskExecutionException;

/**
 * This class provides a wrapper for the NCBI EFetch Utilities.
 * 
 * @author Mark
 */
class EFetchWorker extends AbstractEFetchWorker {

	public Map execute(Map inputMap) throws TaskExecutionException {
		DataThingAdapter inAdapter = new DataThingAdapter(inputMap);
		HashMap outputMap = new HashMap();
		return outputMap;
	}

	public String[] inputNames() {
		return new String[] { "id", "retstart", "retmax", "strand", "seq_start", "seq_stop", "complexity", "retmode",
				"rettype", };
	}

	public String[] inputTypes() {
		return new String[] { "'text/plain'", "'text/plain'", "'text/plain'", "'text/plain'", "'text/plain'",
				"'text/plain'", "'text/plain'", "'text/plain'", "'text/plain'" };
	}

	public String[] outputNames() {
		return new String[] { "outputText" };
	}

	public String[] outputTypes() {
		return new String[] { "'text/plain'" };
	}

}
