/*                Bistro development code
* 
* This code may be freely distributed and modified under the
* terms of the GNU Lesser General Public Licence.  This should
* be distributed with the code.  If you do not have a copy,
* see:
*
*     http://www.gnu.org/copyleft/lesser.html
* 
* Copyright for this code is held jointly by the individual
* authors.  These should be listed in @author doc comments.
* 
*/

package org.starbeans.modules.bistro.onlineservices.ncbi;

import org.starbeans.modules.bistro.onlineservices.OnlineService;
import org.starbeans.modules.bistro.services.BioService;
import org.starbeans.modules.bistro.services.Worker;
import org.openide.util.NbBundle;

/** 
 *
 * @author George Waldon
 */
public class ProteinGenPeptService extends OnlineService {

    private static ProteinGenPeptService service;
    
    public static BioService getDefault() {
        if(service==null)
            service = new ProteinGenPeptService();
        return service;
    }
    
    public String getID() {
        return "bistro:local:ncbi:proteingenpept";
    }

    public ProteinGenPeptService() {
        setName(NbBundle.getMessage(ProteinGenPeptService.class, "DES_ProteinGenPeptWorker"));
    }
    
    @Override
    public Worker getWorker() {
        return new ProteinGenPeptWorker();
    }

    
}
